commit 21811ff3fd95a5325c665cb28b1d65e612a179dc
Author: Jeremy Harris <jgh146exb@wizmail.org>
Date:   Tue Nov 18 18:03:39 2025 +0000

    Testsuite: fix for perl-spf dynamic build

diff --git a/src/src/EDITME b/src/src/EDITME
index a2dddd780..1c9d834dd 100644
--- a/src/src/EDITME
+++ b/src/src/EDITME
@@ -412,6 +412,7 @@ TRANSPORT_SMTP=yes
 # EXTRALIBS so that dlopen() is available to Exim. You need to define
 # LOOKUP_MODULE_DIR above so the exim binary actually loads dynamic lookup
 # modules.
+#
 # Also, instead of adding all the libraries/includes to LOOKUP_INCLUDE and
 # LOOKUP_LIBS, add them to the respective LOOKUP_*_INCLUDE and LOOKUP_*_LIBS
 # (where * is the name as given here in this list). That ensures that only
@@ -1170,6 +1171,7 @@ ZCAT_COMMAND=/usr/bin/zcat
 # SUPPORT_SPF=yes
 # CFLAGS  += -I/usr/local/include
 # LDFLAGS += -lspf2
+# SUPPORT_SPF_LIBS= -lspf2
 
 
 #------------------------------------------------------------------------------
diff --git a/src/src/drtables.c b/src/src/drtables.c
index 9e25472d3..87ff8da61 100644
--- a/src/src/drtables.c
+++ b/src/src/drtables.c
@@ -185,9 +185,13 @@ if (info->magic != LOOKUP_MODULE_INFO_MAGIC)
   }
 
 addlookupmodule(info);
-EARLY_DEBUG(D_lookup, "Loaded %q (%d lookup type%s)\n",
+if (debug_startup)
+  { EARLY_DEBUG(D_lookup, "Loaded %q (%d lookup type%s)\n",
 				    name, info->lookupcount,
-				    info->lookupcount > 1 ? "s" : "");
+				    info->lookupcount > 1 ? "s" : ""); }
+else
+  DEBUG(D_lookup) debug_printf_indent("Loaded module %q\n", name);
+
 return TRUE;
 }
 
@@ -341,7 +345,8 @@ if ((mi = misc_mod_findonly(name))) return mi;
 #ifdef LOOKUP_MODULE_DIR
 return misc_mod_load(name, errstr);
 #else
-*errstr = string_sprintf("module '%s' not found", name);
+*errstr = string_sprintf("module %q not built-in, and"
+	"no setting for LOOKUP_MODULE_DIR", name);
 return NULL;
 #endif	/*LOOKUP_MODULE_DIR*/
 }
@@ -470,7 +475,7 @@ else
   closedir(dd);
   }
 
-EARLY_DEBUG(D_lookup, "Loaded %d lookup modules\n", countmodules);
+EARLY_DEBUG(D_lookup, "Loaded %d dynamic lookup modules\n", countmodules);
 #endif
 }
 
diff --git a/src/src/exim_dbmbuild.c b/src/src/exim_dbmbuild.c
index e3ef848d3..8cb06fefe 100644
--- a/src/src/exim_dbmbuild.c
+++ b/src/src/exim_dbmbuild.c
@@ -55,6 +55,9 @@ void
 store_release_above_3(void *ptr, const char *func, int linenumber)
 { }
 gstring *
+string_catn(gstring * g, const uschar * s, int count)
+{ return NULL; }
+gstring *
 string_vformat_trc(gstring * g, const uschar * func, unsigned line,
   unsigned size_limit, unsigned flags, const char *format, va_list ap)
 { return NULL; }
diff --git a/src/src/lookups/json.c b/src/src/lookups/json.c
index 3e5f9609e..92da9b9cb 100644
--- a/src/src/lookups/json.c
+++ b/src/src/lookups/json.c
@@ -157,8 +157,6 @@ json_close(void *handle)
 
 /* See local README for interface description. */
 
-#include "../version.h"
-
 gstring *
 json_version_report(gstring * g)
 {
diff --git a/src/src/lookups/ldap.c b/src/src/lookups/ldap.c
index b73413a39..0a00633ab 100644
--- a/src/src/lookups/ldap.c
+++ b/src/src/lookups/ldap.c
@@ -1558,8 +1558,6 @@ return quoted;
 
 /* See local README for interface description. */
 
-#include "../version.h"
-
 gstring *
 ldap_version_report(gstring * g)
 {
diff --git a/src/src/lookups/lmdb.c b/src/src/lookups/lmdb.c
index c90632cee..dc8bec3ba 100644
--- a/src/src/lookups/lmdb.c
+++ b/src/src/lookups/lmdb.c
@@ -128,8 +128,6 @@ mdb_env_close(db_env);
 *         Version reporting entry point          *
 *************************************************/
 
-#include "../version.h"
-
 gstring *
 lmdb_version_report(gstring * g)
 {
diff --git a/src/src/lookups/mysql.c b/src/src/lookups/mysql.c
index 76954ca43..f28e9154f 100644
--- a/src/src/lookups/mysql.c
+++ b/src/src/lookups/mysql.c
@@ -467,8 +467,6 @@ return quoted;
 
 /* See local README for interface description. */
 
-#include "../version.h"
-
 gstring *
 mysql_version_report(gstring * g)
 {
diff --git a/src/src/lookups/pgsql.c b/src/src/lookups/pgsql.c
index 8ddf0e058..7071cb4ab 100644
--- a/src/src/lookups/pgsql.c
+++ b/src/src/lookups/pgsql.c
@@ -472,8 +472,6 @@ return quoted;
 
 /* See local README for interface description. */
 
-#include "../version.h"
-
 gstring *
 pgsql_version_report(gstring * g)
 {
diff --git a/src/src/lookups/redis.c b/src/src/lookups/redis.c
index a721d0605..61c264a73 100644
--- a/src/src/lookups/redis.c
+++ b/src/src/lookups/redis.c
@@ -428,7 +428,6 @@ return quoted;
 /*************************************************
 *         Version reporting entry point          *
 *************************************************/
-#include "../version.h"
 
 gstring *
 redis_version_report(gstring * g)
diff --git a/src/src/lookups/spf.c b/src/src/lookups/spf.c
index bfce04fa7..a8404d9bf 100644
--- a/src/src/lookups/spf.c
+++ b/src/src/lookups/spf.c
@@ -81,39 +81,33 @@ return FAIL;
 
 /* See local README for interface description. */
 
-#include "../version.h"
-
 gstring *
 spf_version_report(gstring * g)
 {
-#if EXIM_HAVE_SPF == 2
-return g;
-#else
-int maj, min, patch;
-
-SPF_get_lib_version(&maj, &min, &patch);
-return string_fmt_append(g, "Library version: SPF: Runtime: %d.%d.%d\n",
-      maj, min, patch);
-#endif
+uschar * dummy_errmsg;
+misc_module_info * mi = misc_mod_find(US"spf", &dummy_errmsg);
+return mi && mi->lib_vers_report ? mi->lib_vers_report(g) : g;
 }
 
 
+
 static lookup_info spf_lookup_info = {
-  .name = US"spf",			/* lookup name */
-  .type = 0,				/* not absfile, not query style */
-  .open = spf_open,			/* open function */
-  .check = NULL,			/* no check function */
-  .find = spf_find,			/* find function */
-  .close = spf_close,			/* close function */
-  .tidy = NULL,				/* no tidy function */
-  .quote = NULL,			/* no quoting function */
-  .version_report = spf_version_report             /* version reporting */
+  .name =	US"spf",		/* lookup name */
+  .type =	0,			/* not absfile, not query style */
+  .open =	spf_open,		/* open function */
+  .check =	NULL,			/* no check function */
+  .find =	spf_find,		/* find function */
+  .close =	spf_close,		/* close function */
+  .tidy =	NULL,			/* no tidy function */
+  .quote =	NULL,			/* no quoting function */
+  .version_report = spf_version_report	/* version reporting */
 };
 
-#ifdef notdef_DYNLOOKUP
-#define spf_lookup_module_info _lookup_module_info
+#ifdef DYNLOOKUP
+# define spf_lookup_module_info _lookup_module_info
 #endif
 
 static lookup_info *_lookup_list[] = { &spf_lookup_info };
-lookup_module_info spf_lookup_module_info = { LOOKUP_MODULE_INFO_MAGIC, _lookup_list, 1 };
+lookup_module_info spf_lookup_module_info =
+  { LOOKUP_MODULE_INFO_MAGIC, _lookup_list, 1 };
 
diff --git a/src/src/lookups/sqlite.c b/src/src/lookups/sqlite.c
index e358c9f84..eb23b8631 100644
--- a/src/src/lookups/sqlite.c
+++ b/src/src/lookups/sqlite.c
@@ -163,8 +163,6 @@ return quoted;
 
 /* See local README for interface description. */
 
-#include "../version.h"
-
 gstring *
 sqlite_version_report(gstring * g)
 {
diff --git a/src/src/lookups/whoson.c b/src/src/lookups/whoson.c
index f783a905a..dcd48db2d 100644
--- a/src/src/lookups/whoson.c
+++ b/src/src/lookups/whoson.c
@@ -63,8 +63,6 @@ switch (wso_query(CS query, CS buffer, sizeof(buffer)))
 
 /* See local README for interface description. */
 
-#include "../version.h"
-
 gstring *
 whoson_version_report(gstring * g)
 {
diff --git a/src/src/miscmods/perl.c b/src/src/miscmods/perl.c
index 2220c7dc9..41d946735 100644
--- a/src/src/miscmods/perl.c
+++ b/src/src/miscmods/perl.c
@@ -131,7 +131,8 @@ s = US SvPV(ST(0), len);
 log_write(0, LOG_MAIN, "%.*s", (int)len, s);
 }
 
-/* Do a DNS lookup using Exim's facilities.  Returns a scalar with the response packet. */
+/* Do a DNS lookup using Exim's facilities.
+Returns a scalar with the response packet; undef for DNS_FAIL or DNS_AGAIN. */
 
 XS(xs_dns_lookup)
 {
@@ -154,8 +155,10 @@ debug_printf_indent(" dnsa answer %p len %d\n", dnsa->answer, dnsa->answerlen);
 */
 
 ST(0) = sv_newmortal();
-sv_setpvn(ST(0), CCS dnsa->answer,
-		  (STRLEN) (dns_res == DNS_NODATA ? 0 : dnsa->answerlen));
+if (dns_res == DNS_AGAIN || dns_res == DNS_FAIL)
+  sv_setsv(ST(0), &PL_sv_undef);
+else
+  sv_setpvn(ST(0), CCS dnsa->answer, (STRLEN) dnsa->answerlen);
 XSRETURN(1);	/* ? needed because there are 2 arg, but 1 res? */
 
 store_free_dns_answer(dnsa);
@@ -222,9 +225,11 @@ errstr = exim_perl_add_codeblock(US
 	"\"TLSA\"  => 52,"
 	"\"SPF\"   => 99,"
 	"};"
-	"my $rrtype = $rr->{$rrtype_str};"		/*XXX only one rrtype per query...*/
+	/*XXX only one rrtype per query...*/
+	"my $rrtype = $rr->{$rrtype_str};"
         "my $dnsa = Exim::dns_lookup($dom, $rrtype);"
-	"my $res = Net::DNS::Packet->decode( \\$dnsa );"
+	"my $res;"
+	"my $res = Net::DNS::Packet->decode(\\$dnsa) unless (!defined($dnsa));"
 		/* "Exim::debug_write( $res->string . '\n' );" */
 	"return $res;"
   "}"
diff --git a/src/src/miscmods/spf_perl.c b/src/src/miscmods/spf_perl.c
index 3008facc8..17eb3ce35 100644
--- a/src/src/miscmods/spf_perl.c
+++ b/src/src/miscmods/spf_perl.c
@@ -212,7 +212,7 @@ else
   sep = '\n';
 
   spf_result = string_nextinlist(CUSS &res_list, &sep, NULL, 0);
-  DEBUG(D_acl) debug_printf_indent("SPF result is %s\n", spf_received);
+  DEBUG(D_acl) debug_printf_indent("MAIL::SPF result is %q\n", spf_received);
 
   spf_received = res_list;		/* remainder of the returned string */
 
@@ -329,9 +329,9 @@ spf_lookup_find(void * handle, const uschar * filename,
 {
 int res = FAIL;
 
-expand_level++;
 DEBUG(D_acl) debug_printf_indent("%s: mfrom:<%s> ip %q\n", __FUNCTION__,
 				  keystring, filename);
+expand_level++;
 
 if (setup_spf_perl_mi())
   if (!filename)
@@ -346,11 +346,12 @@ if (setup_spf_perl_mi())
       uschar * res_list = US string_from_gstring(g);
       int sep = '\n';
       *result = string_nextinlist(CUSS &res_list, &sep, NULL, 0);
-      DEBUG(D_acl) debug_printf_indent("SPF result is %s\n", *result);
+      DEBUG(D_acl) debug_printf_indent("MAIL::SPF result is %q\n", *result);
       res = OK;
       }
     }
 
+expand_level--;
 return res;
 }
 

